searchData={"items":[{"type":"module","title":"QuantumStorageEcto","doc":"A storage adapter for `Quantum` based on Ecto","ref":"QuantumStorageEcto.html"},{"type":"module","title":"Installation - QuantumStorageEcto","doc":"The package can be installed by adding `quantum_storage_ecto` to your list of dependencies in mix.exs:\n\n```elixir\ndef deps do\n  [{:quantum_storage_ecto, \"~> 0.1\"}]\nend\n```","ref":"QuantumStorageEcto.html#module-installation"},{"type":"module","title":"How to Use? - QuantumStorageEcto","doc":"Simply add `QuantumStorageEcto` in `Quantum` config and run the required migrations.\n\nThe `Repo` (`Ecto.Repo`) parameter is required and is used to communicate with the database\n\n```elixir\nconfig :my_app, MyApp.Scheduler,\n  storage: QuantumStorageEcto,\n  storage_opts: [\n    repo: MyApp.Repo,\n  ]\n```","ref":"QuantumStorageEcto.html#module-how-to-use"},{"type":"module","title":"Running the migrations - QuantumStorageEcto","doc":"#### Create a new migration file in your application\n```sh\nmix ecto.gen.migration adding_quantum_storage_ecto\n```\n\n#### Edit the newly created migration file\n```elixir\ndefmodule MyApp.Repo.Migrations.AddQuantumJobs do\n  use Ecto.Migration\n  def up do\n    QuantumStorageEcto.Migrations.V1AddJobsTable.up()\n  end\n  def down do\n    QuantumStorageEcto.Migrations.V1AddJobsTable.down()\n  end\nend\n```\n#### Migrate\n```sh\nmix ecto.migrate\n```","ref":"QuantumStorageEcto.html#module-running-the-migrations"},{"type":"module","title":"Database Tables - QuantumStorageEcto","doc":"The adapter creates 2 database tables:\n- `quantum_jobs` - this table stores the job definitions\n- `quantum_last_execution_date` - holds the last execution data","ref":"QuantumStorageEcto.html#module-database-tables"},{"type":"module","title":"QuantumStorageEcto.ExecutionDate","doc":"A model that for a single date value","ref":"QuantumStorageEcto.ExecutionDate.html"},{"type":"function","title":"QuantumStorageEcto.ExecutionDate.changeset/2","doc":"","ref":"QuantumStorageEcto.ExecutionDate.html#changeset/2"},{"type":"type","title":"QuantumStorageEcto.ExecutionDate.t/0","doc":"","ref":"QuantumStorageEcto.ExecutionDate.html#t:t/0"},{"type":"module","title":"QuantumStorageEcto.ExecutionDates","doc":"","ref":"QuantumStorageEcto.ExecutionDates.html"},{"type":"function","title":"QuantumStorageEcto.ExecutionDates.get/1","doc":"Returns the last execution date as stored in the database","ref":"QuantumStorageEcto.ExecutionDates.html#get/1"},{"type":"function","title":"QuantumStorageEcto.ExecutionDates.upsert/2","doc":"Gets the last execution date from the database and updates it with a new value","ref":"QuantumStorageEcto.ExecutionDates.html#upsert/2"},{"type":"function","title":"Parameters - QuantumStorageEcto.ExecutionDates.upsert/2","doc":"- `value` - the new execution date\n- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.ExecutionDates.html#upsert/2-parameters"},{"type":"module","title":"QuantumStorageEcto.Job","doc":"Ecto compatible type for a `Quantum.Job`","ref":"QuantumStorageEcto.Job.html"},{"type":"function","title":"QuantumStorageEcto.Job.changeset/2","doc":"","ref":"QuantumStorageEcto.Job.html#changeset/2"},{"type":"function","title":"QuantumStorageEcto.Job.encode/2","doc":"","ref":"QuantumStorageEcto.Job.html#encode/2"},{"type":"function","title":"QuantumStorageEcto.Job.update_changeset/2","doc":"","ref":"QuantumStorageEcto.Job.html#update_changeset/2"},{"type":"type","title":"QuantumStorageEcto.Job.t/0","doc":"An Ecto representation of a `Quantum.Job`","ref":"QuantumStorageEcto.Job.html#t:t/0"},{"type":"module","title":"QuantumStorageEcto.Jobs","doc":"Functions to interact with the job model","ref":"QuantumStorageEcto.Jobs.html"},{"type":"function","title":"QuantumStorageEcto.Jobs.delete/2","doc":"Deletes a job from the database","ref":"QuantumStorageEcto.Jobs.html#delete/2"},{"type":"function","title":"Parameters - QuantumStorageEcto.Jobs.delete/2","doc":"- `job` - the job object to delete\n- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.Jobs.html#delete/2-parameters"},{"type":"function","title":"QuantumStorageEcto.Jobs.delete_all/1","doc":"Purges all jobs from the database","ref":"QuantumStorageEcto.Jobs.html#delete_all/1"},{"type":"function","title":"Parameters - QuantumStorageEcto.Jobs.delete_all/1","doc":"- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.Jobs.html#delete_all/1-parameters"},{"type":"function","title":"QuantumStorageEcto.Jobs.delete_job_by_name/2","doc":"Deletes a job from the database by its name.","ref":"QuantumStorageEcto.Jobs.html#delete_job_by_name/2"},{"type":"function","title":"Parameters - QuantumStorageEcto.Jobs.delete_job_by_name/2","doc":"- `job_name` - the job name to delete\n- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.Jobs.html#delete_job_by_name/2-parameters"},{"type":"function","title":"QuantumStorageEcto.Jobs.full_update/2","doc":"Perform a full update for the job object. This function requires all the\njob attributes to be updated","ref":"QuantumStorageEcto.Jobs.html#full_update/2"},{"type":"function","title":"Parameters - QuantumStorageEcto.Jobs.full_update/2","doc":"- `job` - the job to update\n- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.Jobs.html#full_update/2-parameters"},{"type":"function","title":"QuantumStorageEcto.Jobs.get_all/1","doc":"Returns all jobs from the database","ref":"QuantumStorageEcto.Jobs.html#get_all/1"},{"type":"function","title":"Parameters - QuantumStorageEcto.Jobs.get_all/1","doc":"- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.Jobs.html#get_all/1-parameters"},{"type":"function","title":"QuantumStorageEcto.Jobs.insert/2","doc":"Inserts a job to the database.","ref":"QuantumStorageEcto.Jobs.html#insert/2"},{"type":"function","title":"Parameters - QuantumStorageEcto.Jobs.insert/2","doc":"- `job_attrs` - the new job attributes\n- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.Jobs.html#insert/2-parameters"},{"type":"function","title":"QuantumStorageEcto.Jobs.update/3","doc":"Updates a job with the provided attribute","ref":"QuantumStorageEcto.Jobs.html#update/3"},{"type":"function","title":"Parameters - QuantumStorageEcto.Jobs.update/3","doc":"- `job_name` - the job name to update. Jobs without atom names are using a `reference` instead\n- `attrs` - a map with the attributes to update\n- `repo` - the repo module that should be use to communicate with the database","ref":"QuantumStorageEcto.Jobs.html#update/3-parameters"},{"type":"module","title":"QuantumStorageEcto.Server","doc":"This GenServer is an implementation fo `Quantum.Storage` and contains\nall the required functions to store Quantum jobs using Ecto","ref":"QuantumStorageEcto.Server.html"},{"type":"function","title":"QuantumStorageEcto.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"QuantumStorageEcto.Server.html#child_spec/1"},{"type":"function","title":"QuantumStorageEcto.Server.start_link/1","doc":"Start the GenServer\nThe required `opts` parameters are `repo` which contains the Ecto Repo\nto communicate with the database","ref":"QuantumStorageEcto.Server.html#start_link/1"},{"type":"module","title":"QuantumStorageEcto.Types.Atom","doc":"Implements and Ecto type that allows to save atoms to a database\n\nReference: https://hexdocs.pm/ecto/Ecto.Type.html","ref":"QuantumStorageEcto.Types.Atom.html"},{"type":"function","title":"QuantumStorageEcto.Types.Atom.cast/1","doc":"","ref":"QuantumStorageEcto.Types.Atom.html#cast/1"},{"type":"function","title":"QuantumStorageEcto.Types.Atom.dump/1","doc":"","ref":"QuantumStorageEcto.Types.Atom.html#dump/1"},{"type":"function","title":"QuantumStorageEcto.Types.Atom.embed_as/1","doc":"","ref":"QuantumStorageEcto.Types.Atom.html#embed_as/1"},{"type":"function","title":"QuantumStorageEcto.Types.Atom.equal?/2","doc":"","ref":"QuantumStorageEcto.Types.Atom.html#equal?/2"},{"type":"function","title":"QuantumStorageEcto.Types.Atom.load/1","doc":"","ref":"QuantumStorageEcto.Types.Atom.html#load/1"},{"type":"function","title":"QuantumStorageEcto.Types.Atom.type/0","doc":"","ref":"QuantumStorageEcto.Types.Atom.html#type/0"},{"type":"module","title":"QuantumStorageEcto.Types.AtomOrRef","doc":"Implements and Ecto type that allows to save a value if its an atom or reference\nHandle with care\n\nReference: https://hexdocs.pm/ecto/Ecto.Type.html","ref":"QuantumStorageEcto.Types.AtomOrRef.html"},{"type":"function","title":"QuantumStorageEcto.Types.AtomOrRef.cast/1","doc":"","ref":"QuantumStorageEcto.Types.AtomOrRef.html#cast/1"},{"type":"function","title":"QuantumStorageEcto.Types.AtomOrRef.dump/1","doc":"","ref":"QuantumStorageEcto.Types.AtomOrRef.html#dump/1"},{"type":"function","title":"QuantumStorageEcto.Types.AtomOrRef.embed_as/1","doc":"","ref":"QuantumStorageEcto.Types.AtomOrRef.html#embed_as/1"},{"type":"function","title":"QuantumStorageEcto.Types.AtomOrRef.equal?/2","doc":"","ref":"QuantumStorageEcto.Types.AtomOrRef.html#equal?/2"},{"type":"function","title":"QuantumStorageEcto.Types.AtomOrRef.load/1","doc":"","ref":"QuantumStorageEcto.Types.AtomOrRef.html#load/1"},{"type":"function","title":"QuantumStorageEcto.Types.AtomOrRef.type/0","doc":"","ref":"QuantumStorageEcto.Types.AtomOrRef.html#type/0"},{"type":"module","title":"QuantumStorageEcto.Types.Reference","doc":"Implements and Ecto type that allows to save references to a database\n\nReference: https://hexdocs.pm/ecto/Ecto.Type.html","ref":"QuantumStorageEcto.Types.Reference.html"},{"type":"function","title":"QuantumStorageEcto.Types.Reference.cast/1","doc":"","ref":"QuantumStorageEcto.Types.Reference.html#cast/1"},{"type":"function","title":"QuantumStorageEcto.Types.Reference.dump/1","doc":"","ref":"QuantumStorageEcto.Types.Reference.html#dump/1"},{"type":"function","title":"QuantumStorageEcto.Types.Reference.embed_as/1","doc":"","ref":"QuantumStorageEcto.Types.Reference.html#embed_as/1"},{"type":"function","title":"QuantumStorageEcto.Types.Reference.equal?/2","doc":"","ref":"QuantumStorageEcto.Types.Reference.html#equal?/2"},{"type":"function","title":"QuantumStorageEcto.Types.Reference.load/1","doc":"","ref":"QuantumStorageEcto.Types.Reference.html#load/1"},{"type":"function","title":"QuantumStorageEcto.Types.Reference.type/0","doc":"","ref":"QuantumStorageEcto.Types.Reference.html#type/0"},{"type":"module","title":"QuantumStorageEcto.Types.Term","doc":"Implements and Ecto type that allows to save any elixir term to a database\n> #### Warning {: .warning}\n>\n> Handle with care, there is no guard validation since every term can be converted to a binary\n\n\nReference: https://hexdocs.pm/ecto/Ecto.Type.html","ref":"QuantumStorageEcto.Types.Term.html"},{"type":"function","title":"QuantumStorageEcto.Types.Term.cast/1","doc":"","ref":"QuantumStorageEcto.Types.Term.html#cast/1"},{"type":"function","title":"QuantumStorageEcto.Types.Term.dump/1","doc":"","ref":"QuantumStorageEcto.Types.Term.html#dump/1"},{"type":"function","title":"QuantumStorageEcto.Types.Term.embed_as/1","doc":"","ref":"QuantumStorageEcto.Types.Term.html#embed_as/1"},{"type":"function","title":"QuantumStorageEcto.Types.Term.equal?/2","doc":"","ref":"QuantumStorageEcto.Types.Term.html#equal?/2"},{"type":"function","title":"QuantumStorageEcto.Types.Term.load/1","doc":"","ref":"QuantumStorageEcto.Types.Term.html#load/1"},{"type":"function","title":"QuantumStorageEcto.Types.Term.type/0","doc":"","ref":"QuantumStorageEcto.Types.Term.html#type/0"},{"type":"extras","title":"QuantumStorageEcto","doc":"# QuantumStorageEcto\n\n[![Coverage Status](https://coveralls.io/repos/github/lsxliron/quantum_storage_ecto/badge.svg?branch=master)](https://coveralls.io/github/lsxliron/quantum_storage_ecto?branch=master)\n[![Hex.pm Version](http://img.shields.io/hexpm/v/quantum_storage_ecto.svg)](https://hex.pm/packages/quantum_storage_ecto)\n[![Hex docs](http://img.shields.io/badge/hex.pm-docs-green.svg?style=flat)](https://hexdocs.pm/quantum_storage_ecto)\n[![Hex.pm](https://img.shields.io/hexpm/dt/quantum_storage_ecto.svg)](https://hex.pm/packages/quantum_storage_ecto)\n\n\n\n**Quantum Storage Adapter based on Ecto**","ref":"readme.html"},{"type":"extras","title":"Installation - QuantumStorageEcto","doc":"The package can be installed by adding `quantum_storage_ecto` to your list of dependencies in mix.exs:\n\n```elixir\ndef deps do\n  [\n    {:quantum_storage_ecto, \"~> 0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"How to Use? - QuantumStorageEcto","doc":"Simply add `QuantumStorageEcto` in `Quantum` config and run the required migrations.\n\nThe `Repo` (`Ecto.Repo`) parameter is required and is used to communicate with the database\n\n```elixir\nconfig :my_app, MyApp.Scheduler,\n  storage: QuantumStorageEcto,\n  storage_opts: [\n    repo: MyApp.Repo,\n  ]\n```","ref":"readme.html#how-to-use"},{"type":"extras","title":"Running the migrations - QuantumStorageEcto","doc":"#### Create a new migration file in your application\n```sh\nmix ecto.gen.migration adding_quantum_storage_ecto\n```\n\n#### Edit the newly created migration file\n```elixir\ndefmodule MyApp.Repo.Migrations.AddQuantumJobs do\n  use Ecto.Migration\n  \n  def up do\n    QuantumStorageEcto.Migrations.V1AddJobsTable.up()\n  end\n  \n  def down do\n    QuantumStorageEcto.Migrations.V1AddJobsTable.down()\n  end\nend\n```\n#### Migrate\n```sh\nmix ecto.migrate\n```","ref":"readme.html#running-the-migrations"},{"type":"extras","title":"Testing - QuantumStorageEcto","doc":"To run the full test suite:\n```sh\nmix test\n```","ref":"readme.html#testing"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}